<template>
  <div
    v-if="gameEntries.length > 0"
    class="sbo-game-list w-full mb-10 mt-6 px-3"
  >
    <template v-for="game in gameEntries" :key="game.GameId">
      <vertical-game-entry-component v-if="isSport" :game="game" />
      <horizontal-game-entry v-else :game="game" />
    </template>
  </div>
  <div
    v-else
    class="col-span-3 my-[60px] overflow-hidden text-xl text-center truncate no-data text-ellipsis"
  >
    {{ $t("no_games_please_come_back_later") }}
  </div>
  <lazy-theme-common-login-dialog
    v-model="dialog"
  ></lazy-theme-common-login-dialog>
</template>
<script lang="ts">
import { defineComponent, computed, ref } from "vue";
import _ from "lodash";
import HorizontalGameEntry from "./HorizontalGameEntry.client.vue";
import VerticalGameEntryComponent from "./VeritcalGameEntry.client.vue";
import { store } from "@/store";
import {
  handleGameEntryOpenWindow,
  useGameEntryBaseOnTabSelected,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";

export default defineComponent({
  name: "GameListEntryComponent",
  components: {
    HorizontalGameEntry,
    VerticalGameEntryComponent,
  },
  setup() {
    const authenticated = computed(() => store.state.auth);
    const isGameLoading = computed(() => store.state.isGameUpdateLoading);
    const { gameEntrySelected, customizeObjectCasinos } =
      useGameEntryBaseOnTabSelected();
    const tabTypeForRoute = computed(() => {
      let result = "";
      gameEntrySelected.value.forEach((item) => {
        result = item?.TabType.replaceAll(" ", "-").toLowerCase();
      });
      return result === ""
        ? `?entrance=${EnumEntranceLocation.GameLobby}`
        : `?tab=${result}&entrance=${EnumEntranceLocation.GameLobby}`;
    });
    const selectedTheme = computed((): string => store.state.selectedThemeName);
    const isSport = computed((): boolean =>
      !_.isEmpty(gameEntrySelected.value)
        ? gameEntrySelected.value[0].Category === 1
        : false
    );
    const gameEntries = computed(() => gameEntrySelected.value);
    const dialog = ref(false);
    return {
      authenticated,
      isGameLoading,
      gameEntrySelected,
      customizeObjectCasinos,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      tabTypeForRoute,
      selectedTheme,
      gameEntries,
      dialog,
      isSport,
    };
  },
});
</script>
<style scoped>
.sbo-game-list {
  /* grid grid-cols-2 gap-2 */
  display: flex;
  flex-wrap: wrap;
  gap: 0.5rem 0.5rem;
}
.sbo-game-list > div {
  width: calc(50% - 0.3rem);
}
</style>
